native job project
-----------------------


## 0. 工程介绍

这是一个 BatchCompute 作业工程, 用来创建 Alicloud BatchCompute 作业.

工程目录结构:

```
 |-- src/             # 作业逻辑代码目录
 |-- .project.json    # 工程描述文件
 |-- job.json         # 作业描述文件
 |-- Readme.md        # 新手必读
```

您可以指定任意可执行文件作为 job 中task 运行的入口.


## 1. 编辑作业代码

### (1) 配置 job.json

使用命令添加 imageId 和 ossPath.

```bash
batchcompute update_project -i <image_id> -o <oss_path>
```

当然, 您也可以手动修改 job.json.

### (2) 修改代码:

代码逻辑都在src目录中, 可以根据业务实际情况修改.

程序运行入口在 job.json 的每个task中 ProgramName字段指定.



## 2. build 工程

```bash
batchcompute build_project
```

这个命令会执行以下操作:

运行 .project.json文件的 build_script 字段中的shell (最终需要在project根目录生成worker.tar.gz)



## 3. 提交作业

```bash
batchcompute submit_job
```

这个命令会做2步操作:

#### 1. 上传 worker.tar.gz 到oss_path

其中 worker.tar.gz 在.project.json的 tar_to_upload 字段中指定,

oss_path 为job.json中的任一个PackageUri.

#### 2. 按照 job.json 提交作业.

