from ..services import printer, client, util


def list(all=False, state=None, order_by='JobId', desc='', limit=-1, watch=True):
    job_list = client.list_jobs()

    # format Date
    job_list = printer.format_date_fields(job_list,['StartTime','EndTime','CreateTime','CreationTime'], util.JOB_KEYS)
    t = job_list

    # filter states
    if state != None:
        t = util.filter_list(t, {'State': state.split(',')})

    # order by
    t = util.order_by(t, order_by.split(','), False if (desc and desc.lower()=='false') else True)

    # limit
    t = t[:int(limit)]

    # calc Progress
    t = util.calc_job_progress(t)

    if all:
        printer.print_arr(t)
    else:
        printer.print_arr(t, util.JOB_COLS)

    printer.print_count(len(t))


def transform_state(state=''):
    return {
        'ready': 'Ready',
        'running': 'Running',
        'failed': 'Failed',
        'finished': 'Finished',
        'stopped': 'Stopped'
    }.get(state.lower())
