from batchcompute import Client

from .config import getConfigs,COMMON

#protected method
def _get_endpoint(region):
    return 'batchcompute.%s.aliyuncs.com' % region

#protected method
def _get_client(opt=None):
    opt = opt or getConfigs(COMMON, ['region','endpoint', 'accesskeyid','accesskeysecret'])
    return Client(opt.get('endpoint') or  _get_endpoint(opt.get('region')),
        opt.get('accesskeyid'), opt.get('accesskeysecret'))

def check_client(opt):
    client = _get_client(opt)
    client.list_images()

def list_images():
    client = _get_client()
    return client.list_images()

def list_jobs():
    client = _get_client()
    return client.list_jobs()
def get_job(job_id):
    client = _get_client()
    return client.get_job(job_id)


def get_job_description(job_id):
    client = _get_client()
    return client.get_job_description(job_id)

def list_tasks(job_id):
    client = _get_client()
    return client.list_tasks(job_id)

def update_job_priority(job_id,priority):
    client = _get_client()
    return client.update_job_priority(job_id, priority)


def start_job(job_id):
    client = _get_client()
    return client.start_job(job_id)


def stop_job(job_id):
    client = _get_client()
    return client.stop_job(job_id)

def remove_job(job_id):
    client = _get_client()
    return client.delete_job(job_id)

def create_job(jobDesc):
    client = _get_client()
    return client.create_job(jobDesc)
