package com.aliyun.batchcompute.job;

import com.aliyun.oss.OSSClient;
import com.aliyun.oss.model.OSSObject;
import com.aliyun.oss.model.ObjectMetadata;

import java.io.ByteArrayInputStream;
import java.io.InputStream;
import java.util.*;

public class Sort {

    public static void main(String[] args){

        //环境变量
        String ossHost = System.getenv("ALI_DIKU_OSS_HOST");
        String taskId = System.getenv("ALI_DIKU_TASK_ID");

        //todo: 需要修改的变量
        String sortOutputPath = "programs/find-prime/data/"+taskId+"-result";

        OSSClient ossClient = new OSSClient(ossHost, Const.ACCESS_KEY_ID, Const.ACCESS_KEY_SECRET);

        StringBuilder sb = new StringBuilder();


        int findInstanceCount = 3;
        for(int i=0;i<findInstanceCount; i++){

            //todo: 需要修改的变量
            String sortInputPath = "programs/find-prime/data/Find-result-"+i;

            OSSObject ossObject = ossClient.getObject(Const.BUCKET, sortInputPath);

            String str = Util.getStringFromInputStream(ossObject.getObjectContent());
            sb.append(str.trim()).append(" ");
        }

        List<String> list = java.util.Arrays.asList(sb.toString().trim().split(" "));

        Collections.sort(list, new Comparator<String>() {
            public int compare(String s, String t1) {
                int a = Integer.parseInt(s.trim());
                int b = Integer.parseInt(t1.trim());
                if(a==b)return 0;
                return a>b?1:-1;
            }
        });


        StringBuilder result = new StringBuilder();
        for(String v: list){
            result.append(v).append(" ");
        }


        String resultStr = result.toString().trim();

        InputStream resultIs = new ByteArrayInputStream(resultStr.getBytes());

        ossClient.putObject(Const.BUCKET, sortOutputPath, resultIs, new ObjectMetadata());

    }
}
